VERSION 2.00
Begin Form frmControl 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Prairie Drive Controller"
   ClientHeight    =   4368
   ClientLeft      =   2568
   ClientTop       =   1380
   ClientWidth     =   5256
   Height          =   5088
   Icon            =   CONTROL.FRX:0000
   Left            =   2532
   LinkTopic       =   "Form1"
   ScaleHeight     =   4368
   ScaleWidth      =   5256
   Top             =   696
   Width           =   5328
   Begin IOPort IOPortC 
      IOPortAddress   =   256
      Left            =   3288
      Top             =   4956
   End
   Begin IOPort IOPortControl 
      IOPortAddress   =   775
      Left            =   4248
      Top             =   4980
   End
   Begin IOPort IOPortB 
      IOPortAddress   =   256
      Left            =   3768
      Top             =   4956
   End
   Begin IOPort IOPortParallel 
      IOPortAddress   =   775
      Left            =   4896
      Top             =   4968
   End
   Begin CheckBox chkFrequencyTrack 
      Caption         =   "Frequency Tracking"
      Height          =   228
      Left            =   2916
      TabIndex        =   61
      Top             =   3996
      Width           =   2172
   End
   Begin TextBox txtModeInfo 
      Height          =   312
      Left            =   1908
      LinkItem        =   "ModeInfo"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   60
      Text            =   " "
      Top             =   6408
      Width           =   2784
   End
   Begin TextBox txtBeacon 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   7.8
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   792
      LinkItem        =   "BeaconMHz"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   59
      Top             =   5148
      Width           =   915
   End
   Begin TextBox txtDownLink 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   7.8
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   792
      LinkItem        =   "DownlinkMHz"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   58
      Top             =   4788
      Width           =   915
   End
   Begin TextBox txtUplink 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   7.8
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   792
      LinkItem        =   "UplinkMHz"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   57
      Top             =   4428
      Width           =   915
   End
   Begin TextBox txtInverting 
      Height          =   312
      Left            =   792
      LinkItem        =   "TransponderInverting"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   56
      Top             =   5508
      Width           =   924
   End
   Begin TextBox txtFreq 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   7.8
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   792
      LinkItem        =   "FreqMHz"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   55
      Top             =   6012
      Width           =   915
   End
   Begin TextBox txtDoppler 
      Height          =   315
      Left            =   792
      LinkItem        =   "DopplerHertz"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   54
      Text            =   "0"
      Top             =   6408
      Width           =   915
   End
   Begin TextBox txtAltAzEl 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   7.8
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   315
      Left            =   2268
      LinkItem        =   "lbl_antenna"
      LinkTopic       =   "FT7361|INFO"
      TabIndex        =   53
      Text            =   "0|0"
      Top             =   5148
      Width           =   915
   End
   Begin CommandButton cmdPanelSwitch 
      Caption         =   "Radios"
      Height          =   372
      Index           =   1
      Left            =   756
      TabIndex        =   33
      Top             =   3924
      Width           =   984
   End
   Begin CommandButton cmdPanelSwitch 
      Caption         =   "Antennas"
      Height          =   372
      Index           =   0
      Left            =   756
      TabIndex        =   44
      Top             =   3924
      Width           =   984
   End
   Begin Frame Frame2 
      Caption         =   "Mode"
      Height          =   552
      Left            =   2412
      TabIndex        =   28
      Top             =   0
      Width           =   2604
      Begin OptionButton optMode 
         Alignment       =   1  'Right Justify
         Caption         =   "Manual"
         Height          =   300
         Index           =   0
         Left            =   180
         TabIndex        =   30
         Top             =   216
         Value           =   -1  'True
         Width           =   960
      End
      Begin OptionButton optMode 
         Caption         =   "Automatic"
         Height          =   300
         Index           =   1
         Left            =   1260
         TabIndex        =   29
         Top             =   216
         Width           =   1200
      End
   End
   Begin Timer Timer1 
      Interval        =   100
      Left            =   4536
      Top             =   5376
   End
   Begin TextBox txtSatName 
      Height          =   312
      Left            =   1224
      LinkItem        =   "SatelliteName"
      LinkTopic       =   "WinOrbit|TrackingInfo"
      TabIndex        =   0
      Text            =   " "
      Top             =   108
      Width           =   1100
   End
   Begin Frame frmAntenna 
      Caption         =   "Elevation"
      Height          =   3196
      Index           =   1
      Left            =   2664
      TabIndex        =   13
      Top             =   648
      Width           =   2556
      Begin TextBox txtElev 
         Height          =   375
         Left            =   1080
         LinkItem        =   "ElevationDegrees"
         LinkTopic       =   "WinOrbit|TrackingInfo"
         TabIndex        =   22
         Text            =   "0"
         Top             =   240
         Width           =   855
      End
      Begin CheckBox chkEnabled 
         Caption         =   "Enabled"
         Height          =   375
         Index           =   1
         Left            =   480
         TabIndex        =   17
         Top             =   1800
         Width           =   1215
      End
      Begin CommandButton cmdElRotate 
         Caption         =   "^"
         Height          =   495
         Index           =   1
         Left            =   1080
         TabIndex        =   16
         Top             =   2280
         Width           =   975
      End
      Begin CommandButton cmdElRotate 
         Caption         =   "v"
         Height          =   495
         Index           =   0
         Left            =   150
         TabIndex        =   15
         Top             =   2280
         Width           =   945
      End
      Begin HScrollBar hscrManualControl 
         Height          =   255
         Index           =   1
         LargeChange     =   10
         Left            =   150
         Max             =   90
         TabIndex        =   14
         Top             =   1200
         Width           =   1905
      End
      Begin Label Label9 
         Alignment       =   1  'Right Justify
         Caption         =   "Target"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   24
         Top             =   360
         Width           =   840
      End
      Begin Label Label9 
         Alignment       =   1  'Right Justify
         Caption         =   "Actual"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   23
         Top             =   720
         Width           =   840
      End
      Begin Label lblSet 
         Alignment       =   2  'Center
         Caption         =   "0"
         Height          =   255
         Index           =   1
         Left            =   600
         TabIndex        =   19
         Top             =   1560
         Width           =   945
      End
      Begin Label lblDeg 
         BorderStyle     =   1  'Fixed Single
         Height          =   360
         Index           =   1
         Left            =   1080
         TabIndex        =   18
         Top             =   720
         Width           =   885
      End
   End
   Begin Frame frmRadio 
      Caption         =   "Radio 1"
      Height          =   3196
      Index           =   1
      Left            =   2664
      TabIndex        =   35
      Top             =   648
      Width           =   2556
      Begin ComboBox cmbModMode 
         Height          =   288
         Index           =   1
         Left            =   1260
         Style           =   2  'Dropdown List
         TabIndex        =   64
         Top             =   2196
         Width           =   876
      End
      Begin CommandButton cmdResetDisplay 
         Caption         =   "Set Disp"
         Height          =   336
         Index           =   1
         Left            =   1656
         TabIndex        =   52
         Top             =   1296
         Width           =   732
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   "<<"
         Height          =   480
         Index           =   4
         Left            =   36
         TabIndex        =   41
         Top             =   1632
         Width           =   600
      End
      Begin CommandButton cmdSetFreq 
         Caption         =   "Set Frq"
         Height          =   336
         Index           =   1
         Left            =   1656
         TabIndex        =   40
         Top             =   972
         Width           =   732
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   "F Dn"
         Height          =   480
         Index           =   5
         Left            =   648
         TabIndex        =   39
         Top             =   1632
         Width           =   600
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   "F Up"
         Height          =   480
         Index           =   6
         Left            =   1260
         TabIndex        =   38
         Top             =   1632
         Width           =   600
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   ">>"
         Height          =   480
         Index           =   7
         Left            =   1872
         TabIndex        =   37
         Top             =   1632
         Width           =   600
      End
      Begin ComboBox cmbRigUsage 
         Height          =   288
         Index           =   1
         Left            =   216
         Style           =   2  'Dropdown List
         TabIndex        =   36
         Top             =   2844
         Width           =   2136
      End
      Begin Label Label5 
         Alignment       =   1  'Right Justify
         Caption         =   "Mode"
         Height          =   300
         Index           =   1
         Left            =   288
         TabIndex        =   65
         Top             =   2232
         Width           =   948
      End
      Begin Label Label2 
         Alignment       =   2  'Center
         Caption         =   "Doppler Correction Mode"
         Height          =   300
         Index           =   1
         Left            =   72
         TabIndex        =   50
         Top             =   2592
         Width           =   2388
      End
      Begin Label lblNetFreq 
         Alignment       =   1  'Right Justify
         BorderStyle     =   1  'Fixed Single
         Caption         =   "144.000000"
         FontBold        =   -1  'True
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   18
         FontStrikethru  =   0   'False
         FontUnderline   =   0   'False
         Height          =   444
         Index           =   1
         Left            =   36
         TabIndex        =   42
         Top             =   504
         Width           =   2352
      End
      Begin Label lblDoppler 
         Alignment       =   1  'Right Justify
         BorderStyle     =   1  'Fixed Single
         Caption         =   "0"
         Height          =   252
         Index           =   1
         Left            =   792
         TabIndex        =   43
         Top             =   1116
         Width           =   696
      End
      Begin Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Dopp"
         Height          =   252
         Index           =   1
         Left            =   36
         TabIndex        =   45
         Top             =   1116
         Width           =   696
      End
      Begin Label Label3 
         Alignment       =   2  'Center
         Caption         =   "Net (MHz)"
         Height          =   252
         Index           =   1
         Left            =   648
         TabIndex        =   48
         Top             =   252
         Width           =   1008
      End
   End
   Begin Frame frmRadio 
      Caption         =   "Radio 0"
      Height          =   3196
      Index           =   0
      Left            =   36
      TabIndex        =   3
      Top             =   648
      Width           =   2556
      Begin ComboBox cmbModMode 
         Height          =   288
         Index           =   0
         Left            =   1260
         Style           =   2  'Dropdown List
         TabIndex        =   62
         Top             =   2196
         Width           =   876
      End
      Begin CommandButton cmdResetDisplay 
         Caption         =   "Set Disp"
         Height          =   336
         Index           =   0
         Left            =   1656
         TabIndex        =   51
         Top             =   1296
         Width           =   732
      End
      Begin ComboBox cmbRigUsage 
         Height          =   288
         Index           =   0
         Left            =   180
         Style           =   2  'Dropdown List
         TabIndex        =   34
         Top             =   2844
         Width           =   2136
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   ">>"
         Height          =   480
         Index           =   3
         Left            =   1872
         TabIndex        =   2
         Top             =   1632
         Width           =   600
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   "F Up"
         Height          =   480
         Index           =   2
         Left            =   1260
         TabIndex        =   31
         Top             =   1632
         Width           =   600
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   "F Dn"
         Height          =   480
         Index           =   1
         Left            =   648
         TabIndex        =   32
         Top             =   1632
         Width           =   600
      End
      Begin CommandButton cmdSetFreq 
         Caption         =   "Set Frq"
         Height          =   336
         Index           =   0
         Left            =   1656
         TabIndex        =   26
         Top             =   972
         Width           =   732
      End
      Begin CommandButton cmdFreqChange 
         Caption         =   "<<"
         Height          =   480
         Index           =   0
         Left            =   36
         TabIndex        =   4
         Top             =   1632
         Width           =   600
      End
      Begin Label Label5 
         Alignment       =   1  'Right Justify
         Caption         =   "Mode"
         Height          =   300
         Index           =   0
         Left            =   288
         TabIndex        =   63
         Top             =   2232
         Width           =   948
      End
      Begin Label Label2 
         Alignment       =   2  'Center
         Caption         =   "Doppler Correction Mode"
         Height          =   300
         Index           =   0
         Left            =   72
         TabIndex        =   49
         Top             =   2592
         Width           =   2388
      End
      Begin Label lblNetFreq 
         Alignment       =   1  'Right Justify
         BorderStyle     =   1  'Fixed Single
         Caption         =   "144.000000"
         FontBold        =   -1  'True
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   18
         FontStrikethru  =   0   'False
         FontUnderline   =   0   'False
         Height          =   444
         Index           =   0
         Left            =   108
         TabIndex        =   25
         Top             =   504
         Width           =   2352
      End
      Begin Label lblDoppler 
         Alignment       =   1  'Right Justify
         BorderStyle     =   1  'Fixed Single
         Caption         =   "0"
         Height          =   252
         Index           =   0
         Left            =   828
         TabIndex        =   47
         Top             =   1116
         Width           =   696
      End
      Begin Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Dopp"
         Height          =   252
         Index           =   0
         Left            =   72
         TabIndex        =   46
         Top             =   1116
         Width           =   696
      End
      Begin Label Label3 
         Alignment       =   2  'Center
         Caption         =   "Net (MHz)"
         Height          =   252
         Index           =   0
         Left            =   720
         TabIndex        =   27
         Top             =   252
         Width           =   1008
      End
   End
   Begin Frame frmAntenna 
      Caption         =   "Azimuth"
      Height          =   3196
      Index           =   0
      Left            =   36
      TabIndex        =   5
      Top             =   648
      Width           =   2556
      Begin CommandButton cmdAzRotate 
         Caption         =   "<"
         Height          =   495
         Index           =   0
         Left            =   150
         TabIndex        =   8
         Top             =   2280
         Width           =   945
      End
      Begin TextBox txtAz 
         Height          =   375
         Left            =   1080
         LinkItem        =   "AzimuthDegrees"
         LinkTopic       =   "WinOrbit|TrackingInfo"
         TabIndex        =   20
         Text            =   "0"
         Top             =   240
         Width           =   855
      End
      Begin HScrollBar hscrManualControl 
         Height          =   255
         Index           =   0
         LargeChange     =   10
         Left            =   150
         Max             =   180
         Min             =   -180
         TabIndex        =   9
         Top             =   1200
         Width           =   1905
      End
      Begin CommandButton cmdAzRotate 
         Caption         =   ">"
         Height          =   495
         Index           =   1
         Left            =   1080
         TabIndex        =   7
         Top             =   2280
         Width           =   975
      End
      Begin CheckBox chkEnabled 
         Caption         =   "Enabled"
         Height          =   375
         Index           =   0
         Left            =   480
         TabIndex        =   6
         Top             =   1800
         Width           =   1215
      End
      Begin Label Label9 
         Alignment       =   1  'Right Justify
         Caption         =   "Target"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   21
         Top             =   360
         Width           =   840
      End
      Begin Label Label9 
         Alignment       =   1  'Right Justify
         Caption         =   "Actual"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   12
         Top             =   720
         Width           =   840
      End
      Begin Label lblDeg 
         BorderStyle     =   1  'Fixed Single
         Height          =   360
         Index           =   0
         Left            =   1080
         TabIndex        =   11
         Top             =   720
         Width           =   885
      End
      Begin Label lblSet 
         Alignment       =   2  'Center
         Caption         =   "0"
         Height          =   255
         Index           =   0
         Left            =   600
         TabIndex        =   10
         Top             =   1560
         Width           =   945
      End
   End
   Begin Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Satellite"
      Height          =   252
      Index           =   0
      Left            =   252
      TabIndex        =   1
      Top             =   144
      Width           =   948
   End
   Begin Menu mnuMenuBar 
      Caption         =   "&File"
      Index           =   0
      Begin Menu mnuFile 
         Caption         =   "E&xit"
         Index           =   5
         Shortcut        =   ^{F4}
      End
   End
   Begin Menu mnuMenuBar 
      Caption         =   "&Setup"
      Index           =   1
      Begin Menu mnuSetup 
         Caption         =   "&Settings"
         Index           =   0
      End
      Begin Menu mnuSetup 
         Caption         =   "&Calibrate Rotators"
         Index           =   1
      End
      Begin Menu mnuSetup 
         Caption         =   "Sa&ve Settings"
         Index           =   2
      End
      Begin Menu mnuSetup 
         Caption         =   "-"
         Index           =   3
      End
      Begin Menu mnuSetup 
         Caption         =   "&Diagnostics"
         Index           =   4
      End
   End
   Begin Menu mnuMenuBar 
      Caption         =   "&Help"
      Index           =   2
      Begin Menu mnuHelp 
         Caption         =   "&Help"
         Index           =   0
      End
      Begin Menu mnuHelp 
         Caption         =   "&Index"
         Index           =   1
         Visible         =   0   'False
      End
      Begin Menu mnuHelp 
         Caption         =   "-"
         Index           =   2
         Visible         =   0   'False
      End
      Begin Menu mnuHelp 
         Caption         =   "-"
         Index           =   3
      End
      Begin Menu mnuHelp 
         Caption         =   "&About"
         Index           =   4
      End
   End
End
Rem rev 6/22/95 CDG - send az/el changes to control routine
Rem                   add man/auto switch for rotors too

Option Explicit
Option Compare Text

Sub chkEnabled_Click (Index As Integer)
Rem When enabling rotators, set the scrollbar to the current
Rem    actual value (if not null)

Select Case Index
    Case 0 ' Az
        Az.Enabled = chkEnabled(0).Value
    Case 1 ' El
        El.Enabled = chkEnabled(1).Value
End Select

Rem Is this really needed ?
If optMode(0).Value Then ' manual mode
    'txtAz = lblDeg(0)
    'txtElev = lblDeg(1)
End If

End Sub

Sub cmbModMode_Click (Index As Integer)
Rem Set Radio mode
Dim RadioCmd As String

If InStr(Radio(Index).TuningType, "RS232") = 0 Then Exit Sub

Select Case Radio(Index).RigType
    Case "Kenwood"
        Select Case cmbModMode(Index).List(cmbModMode(Index).ListIndex)
            Case "LSB"
                RadioCmd = "MD1;"
            Case "USB"
                RadioCmd = "MD2;"
            Case "CW"
                RadioCmd = "MD3;"
            Case "FM"
                RadioCmd = "MD4;"
            Case "FSK"
                RadioCmd = "MD6;"
            Case Else   ' USB
                RadioCmd = "MD2;"
        End Select
        PutCommString Radio(Index).CommPortID, RadioCmd
    Case "Yaesu"
        RadioCmd = Chr$(0) & Chr$(0) & Chr$(0) & Chr$(&H17) ' Rx mode
        If Radio(Index).VFOIndex = 1 Then
        RadioCmd = Chr$(0) & Chr$(0) & Chr$(0) & Chr$(&H27) ' Tx mode
        End If
        Select Case cmbModMode(Index).List(cmbModMode(Index).ListIndex)
            Case "LSB"
                RadioCmd = Chr$(0) & RadioCmd
            Case "USB"
                RadioCmd = Chr$(1) & RadioCmd
            Case "CW"
                RadioCmd = Chr$(2) & RadioCmd
            Case "CWN"
                RadioCmd = Chr$(&H82) & RadioCmd
            Case "FM"
                RadioCmd = Chr$(8) & RadioCmd
            Case "FMN"
                RadioCmd = Chr$(&H88) & RadioCmd
            Case Else    ' USB
                RadioCmd = Chr$(1) & RadioCmd
        End Select
        PutCommString Radio(Index).CommPortID, RadioCmd
        YaesuDelay
    Case "Icom"  ' based on the IC-275/475/271/275 for now
        RadioCmd = Chr$(&HFE) & Chr$(&HFE) & Chr$(Radio(Index).DeviceAddress) & Chr$(&HE)
        Select Case cmbModMode(Index).List(cmbModMode(Index).ListIndex)
            Case "LSB"
                RadioCmd = RadioCmd & Chr$(&H6) & Chr$(&H0) & Chr$(&HFD)
            Case "USB"
                RadioCmd = RadioCmd & Chr$(&H6) & Chr$(&H1) & Chr$(&HFD)
            Case "CW"
                RadioCmd = RadioCmd & Chr$(&H6) & Chr$(&H3) & Chr$(&HFD)
            Case "FM"
                RadioCmd = RadioCmd & Chr$(&H6) & Chr$(&H5) & Chr$(&HFD)
            Case Else  ' USB
                RadioCmd = RadioCmd & Chr$(&H6) & Chr$(&H1) & Chr$(&HFD)
        End Select
        PutCommString Radio(Index).CommPortID, RadioCmd
    Case Else
End Select

End Sub

Sub cmbRigUsage_Click (Index As Integer)
Rem Need to fix the net freq cases
Dim Temp As Integer

Select Case cmbRigUsage(Index).ListIndex

    Case 0   ' None - turn off doppler correction
        Radio(Index).LinkDirection = 0
        Radio(Index).DoppFreq = 0
    Case 1  ' Uplink
        Radio(Index).LinkDirection = -1
        Radio(Index).DoppFreq = Val(txtUplink)
        Radio(Index).DisplayFreq = Val(txtUplink)
    Case 2   ' Downlink
        Radio(Index).LinkDirection = 1
        Radio(Index).DoppFreq = Val(txtDownLink)
        Radio(Index).DisplayFreq = Val(txtDownLink)
    Case 3  ' Uplink - correct all
        Radio(Index).LinkDirection = -1
        Radio(Index).DoppFreq = Val(txtUplink) + TransponderInverting * Val(txtDownLink)
        Radio(Index).DisplayFreq = Val(txtUplink)
    Case 4   ' Downlink - correct all
        Radio(Index).LinkDirection = 1
        Radio(Index).DoppFreq = Val(txtDownLink) + TransponderInverting * Val(txtUplink)
        Radio(Index).DisplayFreq = Val(txtDownLink)
    Case 5   ' Beacon - like downlink...
        Radio(Index).LinkDirection = 1
        Radio(Index).DoppFreq = Val(txtBeacon)
        Radio(Index).DisplayFreq = Val(txtBeacon)
End Select

    UpdateFreq Index

End Sub

Sub cmdAzRotate_MouseDown (Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

Rem Mouse is down, set rotate bits

Select Case Index
    Case 0 ' left
        'If Az.Enabled Then RotateAzimuth "left", "Start"
        RotateAzimuth "left", "Start"
    Case 1 ' right
        'If Az.Enabled Then RotateAzimuth "right", "Start"
        RotateAzimuth "right", "Start"
End Select
Az.ManualOverRide = True

End Sub

Sub cmdAzRotate_MouseUp (Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

If Az.Enabled Then RotateAzimuth "", "End"
'RotateAzimuth "", "End"

Az.ManualOverRide = False

Rem Set the scroll-bar to match
If Int(Az.CurrentPos) > 180 Then
    hscrManualControl(0).Value = LimitSetpoint(Az.CurrentPos - 360, Az)
Else
    hscrManualControl(0).Value = LimitSetpoint(Az.CurrentPos, Az)
End If

End Sub

Sub cmdElRotate_MouseDown (Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

Select Case Index
    Case 0 ' Down
        'If El.Enabled Then RotateElevation "down", "Start"
        RotateElevation "down", "Start"
    Case 1' up
        'If El.Enabled Then RotateElevation "up", "Start"
        RotateElevation "up", "Start"
End Select
El.ManualOverRide = True

End Sub

Sub cmdElRotate_MouseUp (Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

If El.Enabled Then RotateElevation "", "End"
'RotateElevation "", "End"

El.ManualOverRide = False

Rem Set the scroll-bar to match
If Int(El.CurrentPos) > 90 Then
    hscrManualControl(1).Value = LimitSetpoint(90, El)
Else
    hscrManualControl(1).Value = LimitSetpoint(El.CurrentPos, El)
End If

End Sub

Sub cmdFreqChange_Click (Index As Integer)
Dim Delta As Double, RadioIndex As Integer
Dim OldFreq As Double

RadioIndex = Int(Index / 4)
OldFreq = Val(frmControl!lblNetFreq(RadioIndex))

Rem Delta is the change in MHz
Select Case Index Mod 4
    Case 0 ' Big step down
        Delta = -Radio(RadioIndex).TuneStep * 10
    Case 1 ' Small step down
        Delta = -Radio(RadioIndex).TuneStep
    Case 2 ' Small step up
        Delta = Radio(RadioIndex).TuneStep
    Case 3 ' Big step up
        Delta = Radio(RadioIndex).TuneStep * 10
End Select

Radio(RadioIndex).DisplayFreq = OldFreq + Delta / 1000000#
UpdateFreq RadioIndex
If chkFrequencyTrack.Value = 1 Then UpdateOtherFreq RadioIndex, Delta / 1000000#

End Sub

Sub cmdPanelSwitch_Click (Index As Integer)
Rem Display Radios or Antennas as desired

Dim I As Integer

cmdPanelSwitch(0).Visible = True
cmdPanelSwitch(1).Visible = True

Select Case Index
    Case 0 ' antennas
        frmRadio(0).Visible = False
        frmRadio(1).Visible = False
        frmAntenna(0).Visible = True
        frmAntenna(1).Visible = True
        cmdPanelSwitch(Index).Visible = False
        chkFrequencyTrack.Visible = False
    Case 1 ' radios
        chkFrequencyTrack.Visible = True
        frmAntenna(0).Visible = False
        frmAntenna(1).Visible = False
        While I < NRadios
            frmRadio(I).Visible = True
            I = I + 1
        Wend
        cmdPanelSwitch(Index).Visible = False
End Select
StartupPanel = cmdPanelSwitch(Index).Caption

End Sub

Sub cmdResetDisplay_Click (Index As Integer)
Rem Reset the display frequency to match the screen
Rem Similar to UpdateFreq except don't change the rig itself,
Rem    only the software copy

Dim Freq As Double, Response As String
Dim Doppler As Double, NewFreq As Double, TargetFreq As Double

Response = InputBox$("New Display in MHz", "WinPrairie Frequency Entry", lblNetFreq(Index))
If IsNumeric(Response) Then
    Radio(Index).DisplayFreq = Val(Response)
    lblNetFreq(Index) = FormatFrequency(Val(Response))
Rem Round-off to closest available frequency
    Doppler = NewDoppFactor * Radio(Index).DoppFreq * Radio(Index).LinkDirection
    NewFreq = Abs(Radio(Index).DisplayFreq - Radio(Index).LOOffsetFreq + Doppler / 1000000#)
    TargetFreq = (Radio(Index).TuneStep / 1000000#) * Int(.5 + NewFreq * 1000000# / Radio(Index).TuneStep)
    Radio(Index).ActualFreq = TargetFreq
End If

End Sub

Sub cmdSetFreq_Click (Index As Integer)

lblNetFreq_DblClick Index

End Sub

Function FixAz (Azimuth As Single) As Integer

FixAz = Azimuth
If Azimuth > 179 Then FixAz = Azimuth - 360
If Azimuth < -180 Then FixAz = Azimuth + 360

End Function

Sub Form_Load ()
Dim I As Integer, J As Integer

AboutBox!Cmd_OK.Visible = False
AboutBox.Show
DoEvents

StartFlag = False

Rem Get .INI file name (from command line, possibly)
IniFileName = CurDir$ & "\wprairie.ini"
If Command$ <> "" Then
    Rem Try for a full path
    If Dir$(Command$) <> "" And Dir$(Command$) <> Command$ Then
        IniFileName = Command$
    Else ' not a full path, just a filename
        Rem Try for a file in the current directory
        If Dir$(CurDir$ & "\" & Command$) <> "" Then IniFileName = CurDir$ & "\" & Command$
    End If
End If

Rem Set up any constants, flags, etc
Rem Mostly read from .INI file.
Rem (No actions at this point, yet)
    GetSettings                 ' General prefs
    InitializeRotorParams       ' Rotor stuff
    InitializePrairieParams     ' Prairie Board stuff
    InitializeParallelParams    ' Parallel port
    If NRadios <> 0 Then
    For I = 0 To NRadios - 1
        InitializeRadioParams (I) ' Radio stuff
        frmRadio(I).Caption = Radio(I).RadioName
    Next I
    End If
    MeasureCPUTiming            ' timing stuff

Rem Set up hardware ports, etc.
    InitParallelHdw
    InitPrairieHdw
    InitRotorHdw
    If NRadios <> 0 Then
    For I = 0 To NRadios - 1
        If Radio(I).TuningType = "RS232MAIN" Or Radio(I).TuningType = "RS232RIT" Then
            Radio(I).CommPortID = InitCommPort(Radio(I).CommPort, Radio(I).BaudRate)
        End If
        InitRig I
    Next I

    Rem Load more combo boxes
    For I = 0 To NRadios - 1
        cmbRigUsage(I).AddItem "None"
        cmbRigUsage(I).AddItem "Uplink"
        cmbRigUsage(I).AddItem "Downlink"
        cmbRigUsage(I).AddItem "Net (on uplink)"
        cmbRigUsage(I).AddItem "Net (on downlink)"
        cmbRigUsage(I).AddItem "Beacon"
        cmbRigUsage(I).ListIndex = 0

        cmbModMode(I).AddItem "USB"
        cmbModMode(I).AddItem "LSB"
        cmbModMode(I).AddItem "CW"
        cmbModMode(I).AddItem "CWN"
        cmbModMode(I).AddItem "FM"
        cmbModMode(I).AddItem "FMN"
        cmbModMode(I).AddItem "FSK"
        cmbModMode(I).ListIndex = 0
    Next I
    End If

Select Case StartupPanel
    Case "Antennas"
        cmdPanelSwitch_Click 0
    Case "Radios"
        cmdPanelSwitch_Click 1
End Select

Rem Let the screen catch up
Me.Show
If ShowDiags Then frmDiags.Show
DoEvents ' Let the timer read the ADC's, etc.

Rem Set the screen to match the current hardware state
    hscrManualControl(0).Value = LimitSetpoint(Az.CurrentPos, Az)
    hscrManualControl(1).Value = LimitSetpoint(El.CurrentPos, El)
    DoEvents

Rem Go to work
Unload AboutBox
DoEvents
If AutoMode Then optMode(1) = True
If Az.Enabled Then chkEnabled(0) = 1
If El.Enabled Then chkEnabled(1) = 1
If NRadios = 0 Then Exit Sub
For I = 0 To NRadios - 1
    For J = 0 To cmbRigUsage(I).ListCount - 1
        If Radio(I).CompType = cmbRigUsage(I).List(J) Then
            cmbRigUsage(I).ListIndex = J
            Exit For
        End If
    Next J
    For J = 0 To cmbModMode(I).ListCount - 1
        If Radio(I).Mode = cmbModMode(I).List(J) Then
            cmbModMode(I).ListIndex = J
            Exit For
        End If
    Next J
Next I

End Sub

Sub hscrManualControl_Change (Index As Integer)

lblSet(Index) = PositiveAngle((hscrManualControl(Index).Value))

End Sub

Sub hscrManualControl_Scroll (Index As Integer)

lblSet(Index) = PositiveAngle((hscrManualControl(Index).Value))

End Sub

Sub lblNetFreq_DblClick (Index As Integer)
Dim Response As String
Dim Freq As Double
Rem Change the frequency

    Freq = Val(lblNetFreq(Index))
    Response = InputBox$("New Frequency in MHz", "WinPrairie Frequency Entry", lblNetFreq(Index))
    If IsNumeric(Response) Then
        Radio(Index).DisplayFreq = Val(Response)
        UpdateFreq Index
        If chkFrequencyTrack.Value = 1 Then UpdateOtherFreq Index, Radio(Index).DisplayFreq - Freq
    End If

End Sub

Sub mnuFile_Click (Index As Integer)
Dim I As Integer

If NRadios <> 0 Then
    For I = 0 To NRadios - 1
        ShutdownRig I
        CloseCommPort Radio(I).CommPortID
    Next I
End If
    CloseCommPort AntennaCommPortID
    CloseParallelHdw
    Unload Me
    End   ' end the program!

End Sub

Sub mnuHelp_Click (Index As Integer)
Dim HelpErr As Integer

Select Case Index
    Case 0 ' Help
        HelpErr = WinHelp(Me.hWnd, "Wprairie.HLP", HELP_KEY, ByVal "table of contents")
    Case 4 ' About
        AboutBox.Show 1
End Select


End Sub

Sub mnuSetup_Click (Index As Integer)

Select Case Index
    Case 0 ' Parameters
        frmSetup.Show
    Case 1 ' Calibration
        frmDiags.Show
        frmCalibrate.Show
    Case 2 ' Save settings
        SaveSettings
    Case 4 '
        frmDiags.Show
    Case Else
End Select

End Sub

Sub optMode_Click (Index As Integer)
Rem This starts up the radio interface
Dim ErrText As String

On Error GoTo No_DDE
Select Case Index
    Case 1 ' automatic mode
        AutoMode = True
        ErrText = "WinOrbit: Satellite Name"
        txtSatName.LinkMode = 1 ' automatic
        
        ErrText = "WinOrbit: Doppler"
        txtDoppler.LinkMode = 1 ' automatic
        ErrText = "WinOrbit: Satellite Name"
        txtFreq.LinkMode = 1 ' automatic

        ErrText = "WinOrbit: Mode Info"
        txtModeInfo.LinkMode = 1
        ErrText = "WinOrbit: Uplink Freq"
        txtUplink.LinkMode = 1
        ErrText = "WinOrbit: Downlink Freq"
        txtDownLink.LinkMode = 1
        ErrText = "WinOrbit: Beacon Freq"
        txtBeacon.LinkMode = 1
        ErrText = "WinOrbit: Inverting flag"
        txtInverting.LinkMode = 1
        Rem Let all the links update
        DoEvents
        SatDataChanged

        Rem Handle alternate Az/El server (e.g. FT7361.EXE by WB1BQE)
        If AzElServerTopic <> "" Then
            txtAltAzEl.LinkTopic = AzElServerTopic
            txtAltAzEl.LinkItem = AzElServerItem
            ErrText = AzElServerTopic & ": " & AzElServerItem
            txtAltAzEl.LinkMode = 1
        Else   ' default to WinOrbit
            ErrText = "WinOrbit: Azimuth"
            txtAz.LinkMode = 1 ' automatic
            ErrText = "WinOrbit: Elevation"
            txtElev.LinkMode = 1 ' automatic
        End If
        
        Rem Point antennas now if necessary
        If Val(txtElev.Text) > MinElevation Then
           frmControl!hscrManualControl(0).Value = LimitSetpoint(FixAz(Int(Val(txtAz.Text))), Az)
           frmControl!hscrManualControl(1).Value = LimitSetpoint(Val(txtElev.Text), El)
        End If
    Case 0 ' manual mode
        AutoMode = False
        txtDoppler.LinkMode = 0
        txtAz.LinkMode = 0
        txtElev.LinkMode = 0
        txtSatName.LinkMode = 0
        txtFreq.LinkMode = 0
End Select

On Error GoTo 0 '?

Exit Sub

No_DDE:
    'Resume Give_Up
'Give_Up:
    'On Error GoTo 0
    If ShowDiags Then
        frmDiags!lblStatus.Caption = "Status: DDE Error on" & ErrText
    End If
    Resume Next
End Sub

Sub SatDataChanged ()
Rem This routine is called whenever the satellite freq
Rem    data from WinOrbit changes

Dim I As Integer

Rem Update the diags screen
If ShowDiags Then
    frmDiags!txtUplink = txtUplink
    frmDiags!txtModeInfo = txtModeInfo
    frmDiags!txtInverting = txtInverting
    frmDiags!txtDownLink = txtDownLink
    frmDiags!txtBeacon = txtBeacon
    frmDiags!txtInverting = txtInverting
    frmDiags!txtFreq = txtFreq
End If

If NRadios = 0 Then Exit Sub
For I = 0 To NRadios - 1
    cmbRigUsage_Click I
Next I

End Sub

Sub Timer1_Timer ()
Rem Once every so often, do stuff

Select Case AntennaControlType
Case "Prairie"
Rem The first part of this updates all the displays and
Rem    variables relating to the current state of the rotator
    Rem Get current rotor positions
    Az.ADC.Value = ReadADC(Az.ADC.Channel)
    El.ADC.Value = ReadADC(El.ADC.Channel)
    
    Rem Convert to degrees and display
    Az.LastPos = Az.CurrentPos
    El.LastPos = El.CurrentPos
    Az.CurrentPos = ADCToAngle(Az)
    El.CurrentPos = ADCToAngle(El)
    If Az.CurrentPos < 0 Then
        lblDeg(0).Caption = Int(Az.CurrentPos) + 360
    Else
        lblDeg(0).Caption = Int(Az.CurrentPos)
    End If
    lblDeg(1).Caption = Int(El.CurrentPos)

    Rem Show on Diagnostic form for calibrations, etc.
    If ShowDiags Then
        frmDiags!txtADC(Az.ADC.Channel) = Az.ADC.Value
        frmDiags!txtVolts(Az.ADC.Channel) = Format$(Az.ADC.Volts, "##0.00")
        frmDiags!txtDeg(Az.ADC.Channel) = Format$(Az.CurrentPos, "###0.0")
        frmDiags!txtADC(El.ADC.Channel) = El.ADC.Value
        frmDiags!txtVolts(El.ADC.Channel) = Format$(El.ADC.Volts, "##0.00")
        frmDiags!txtDeg(El.ADC.Channel) = Format$(El.CurrentPos, "###0.0")
    End If
    
Rem Now see if action is required for control purposes
    UpdatePhysicalAntennas

Case "Serial"
    If (El.CurrentPos <> Val(lblSet(1))) And El.Enabled Then
        PutCommString AntennaCommPortID, "E " & lblSet(1) & Chr$(13)
        lblDeg(1) = lblSet(1)
        El.CurrentPos = lblSet(1)
    End If
    If (Az.CurrentPos <> Val(lblSet(0))) And Az.Enabled Then
        PutCommString AntennaCommPortID, "A " & lblSet(0) & Chr$(13)
        lblDeg(0) = lblSet(0)
        Az.CurrentPos = lblSet(0)
    End If
Case "Announcer"
    If ((El.CurrentPos <> Val(lblSet(1))) And El.Enabled) Or ((Az.CurrentPos <> Val(lblSet(0))) And Az.Enabled) Then
        Announce "Az", (lblSet(0))
        Announce "El", (lblSet(1))
    End If
    If (El.CurrentPos <> Val(lblSet(1))) And El.Enabled Then
        lblDeg(1) = lblSet(1)
        El.CurrentPos = lblSet(1)
    End If
    If (Az.CurrentPos <> Val(lblSet(0))) And Az.Enabled Then
        lblDeg(0) = lblSet(0)
        Az.CurrentPos = lblSet(0)
    End If
End Select

End Sub

Sub txtAltAzEl_Change ()
Rem Parse string from Ft7361.EXE, etc., to get Az, El

If InStr(txtAltAzEl, "|") > 0 Then
    frmControl!txtAz = Val(Left$(txtAltAzEl, InStr(txtAltAzEl, "|")))
    frmControl!txtElev = Val(Right$(txtAltAzEl, Len(txtAltAzEl) - InStr(txtAltAzEl, "|")))
End If

If ShowDiags Then frmDiags!txtAltAzEl = txtAltAzEl

End Sub

Sub txtAz_Change ()
Rem Azimuth changed.
Dim Temp As Integer

If optMode(1).Value And Val(txtElev) > StartElevation Then
   Temp = FixAz(Int(Val(txtAz)))
   frmControl!hscrManualControl(0).Value = LimitSetpoint((Temp), Az)
End If

End Sub

Sub txtBeacon_Change ()
Rem Set the frequency when the satellite changes

SatDataChanged

End Sub

Sub txtBeacon_LinkOpen (Cancel As Integer)

'SatDataChanged

End Sub

Sub txtDoppler_Change ()
Rem This changes when WPrairie updates the Info
Rem We compute the velocity factor (Doppler/Freq)
Rem   for use in correcting any frequency
Dim I As Integer

If Not frmControl!optMode(1).Value Then Exit Sub     ' manual mode, exit
If AntennaControlType = "Serial" Then
    PutCommString AntennaCommPortID, "F " & txtFreq & Chr$(13)
    PutCommString AntennaCommPortID, "D " & txtDoppler & Chr$(13)
End If

If NRadios = 0 Then Exit Sub

If StartFlag Then  ' already running
    Rem Get doppler factor and apply it
    NewDoppFactor = Val(txtDoppler) / Val(txtFreq)
    For I = 0 To NRadios - 1
        Radio(I).DoppFactor = NewDoppFactor
        UpdateFreq I
    Next I
Else                ' get started
    StartFlag = True
    NewDoppFactor = Val(txtDoppler) / Val(txtFreq)
End If

If ShowDiags Then frmDiags!txtDoppler = txtDoppler

End Sub

Sub txtDownLink_Change ()

Rem Set the frequency when the satellite changes
SatDataChanged

End Sub

Sub txtDownLink_LinkOpen (Cancel As Integer)

'SatDataChanged

End Sub

Sub txtElev_Change ()
Rem Elevation changed

If optMode(1).Value And Val(txtElev.Text) > StartElevation Then
    Select Case Val(txtElev.Text)
        Case Is < MinElevation
            frmControl!hscrManualControl(1).Value = LimitSetpoint(MinElevation, El)
        Case Is > MinElevation ' but hopefully < 90
            frmControl!hscrManualControl(1).Value = LimitSetpoint(Val(txtElev.Text), El)
    End Select
End If

End Sub

Sub txtFreq_Change ()

If ShowDiags Then frmDiags!txtFreq = txtFreq

End Sub

Sub txtFreq_LinkOpen (Cancel As Integer)

If ShowDiags Then frmDiags!txtFreq = txtFreq

End Sub

Sub txtInverting_Change ()
Rem Flag for inverting transponder

TransponderInverting = 1
If txtInverting = "True" Then TransponderInverting = -1
SatDataChanged

End Sub

Sub txtInverting_LinkOpen (Cancel As Integer)

TransponderInverting = 1
If txtInverting = "True" Then TransponderInverting = -1
SatDataChanged

End Sub

Sub txtModeInfo_Change ()

SatDataChanged

End Sub

Sub txtModeInfo_LinkOpen (Cancel As Integer)

'SatDataChanged

End Sub

Sub txtSatName_KeyPress (KeyAscii As Integer)

If KeyAscii = 13 Then
    txtSatName.LinkPoke
End If

End Sub

Sub txtUplink_Change ()
Rem Set the frequency when the satellite changes

SatDataChanged

End Sub

Sub txtUplink_LinkOpen (Cancel As Integer)

'SatDataChanged

End Sub

